# ATLS\Api\RestapiApi

All URIs are relative to *https://rts.at-ls.com/atrts*

Method | HTTP request | Description
------------- | ------------- | -------------
[**delFileByToken**](RestapiApi.md#delfilebytoken) | **POST** /delFileByToken | delFileByToken
[**getFileByToken**](RestapiApi.md#getfilebytoken) | **POST** /getFileByToken | getFileByToken
[**getList**](RestapiApi.md#getlist) | **GET** /getList | getList
[**getgetFileByToken**](RestapiApi.md#getgetfilebytoken) | **GET** /getFileByToken | getFileByToken
[**ping**](RestapiApi.md#ping) | **GET** /ping | ping
[**translateAsynchronous**](RestapiApi.md#translateasynchronous) | **POST** /translateAsynchronous | translateAsynchronous
[**translateSynchronous**](RestapiApi.md#translatesynchronous) | **POST** /translateSynchronous | translateSynchronous

# **delFileByToken**
> \ATLS\Api\Model\OutFile delFileByToken($body)

delFileByToken

Method exclusively designed to cancel an asynchronous translation request via a unique token (generated in the asynchronous translation request). A request can only be cancelled if it has not started to be processed. The status key indicates the <b>status</b> of the translation. Possible values for asynchronous translations are:<ul><li>10: Under review</li><li>20: Ready and to be delivered</li><li>30: Delivered</li><li>40: Deleted</li><li>50: Delivery expired</li><li>90: Document entry error</li><li>100: Processing error</li><ul>The <b>filename</b> key indicates the name of the file, the base64 key indicates the content of the file in base64 if the request is in status 30 (delivered) and the wordcount key indicates the number of words in the file translated. If the document has already been deleted, the errorCode field shall contain the value 404. If the document cannot be deleted because the translation has already been started, the errorCode field will contain the value 403.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \stdClass; // object | Document information to be deleted

try {
    $result = $apiInstance->delFileByToken($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->delFileByToken: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**object**](../Model/object.md)| Document information to be deleted |

### Return type

[**\ATLS\Api\Model\OutFile**](../Model/OutFile.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getFileByToken**
> \ATLS\Api\Model\OutFile getFileByToken($body)

getFileByToken

Method designed exclusively to request the result of asynchronous translation requests through a unique token (generated in the asynchronous translation request). The status key indicates the translation status. The possible values for asynchronous translations are:<ul><li>10: Under review</li><li>20: Ready and pending delivery</li><li>30: Delivered</li><li>40: Deleted</li><li>50: Expired delivery</li><li>90: Documental entry error</li><li>100: Processing error</li><ul>The <b>filename</b> key indicates the name, the base64 key indicates the file content in base64 if the request is in status 30 (delivered), and the wordcount key indicates the number of translated words in the file.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \stdClass; // object | Example of a revised file request

try {
    $result = $apiInstance->getFileByToken($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->getFileByToken: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**object**](../Model/object.md)| Example of a revised file request |

### Return type

[**\ATLS\Api\Model\OutFile**](../Model/OutFile.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getList**
> \ATLS\Api\Model\OutList getList($projectid, $sourcelang, $targetlang, $datecutoff, $options)

getList

Request designed to check the status of all requested translation requests, whether synchronous or asynchronous. The results can be filtered using the date of sending the translation order requests, in Zulu format.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$projectid = 56; // int | Translation project identifier.
$sourcelang = "sourcelang_example"; // string | Source language code in ISO-639-3 format.
$targetlang = "targetlang_example"; // string | Target language code in ISO-639-3 format.
$datecutoff = "datecutoff_example"; // string | Cut-off date, in the following format: YYYYY-MM-DDTHH:MI:SSZ (UTC or Zulu time).
$options = "options_example"; // string | JSON auxiliary options.

try {
    $result = $apiInstance->getList($projectid, $sourcelang, $targetlang, $datecutoff, $options);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->getList: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **projectid** | **int**| Translation project identifier. |
 **sourcelang** | **string**| Source language code in ISO-639-3 format. |
 **targetlang** | **string**| Target language code in ISO-639-3 format. |
 **datecutoff** | **string**| Cut-off date, in the following format: YYYYY-MM-DDTHH:MI:SSZ (UTC or Zulu time). |
 **options** | **string**| JSON auxiliary options. | [optional]

### Return type

[**\ATLS\Api\Model\OutList**](../Model/OutList.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **getgetFileByToken**
> \ATLS\Api\Model\OutFile getgetFileByToken($projectid, $token, $options)

getFileByToken

Method designed exclusively to request the result of asynchronous translation requests through a unique token (generated in the asynchronous translation request). To ensure that the operation of this method is correct in the event of a GET type request, the token must be encoded in URL format. The status key indicates the translation status. The possible values for asynchronous translations are:<ul><li>10: Under review</li><li>20: Ready and pending delivery</li><li>30: Delivered</li><li>40: Deleted</li><li>50: Expired delivery</li><li>90: Documental entry error</li><li>100: Processing error</li><ul>The <b>filename</b> key indicates the name, the base64 key indicates the file content in base64 if the request is in status 30 (delivered), and the wordcount key indicates the number of translated words in the file.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$projectid = 56; // int | Translation project identifier.
$token = "token_example"; // string | Token resulting from the asynchronous translation request.
$options = "options_example"; // string | JSON auxiliary options.

try {
    $result = $apiInstance->getgetFileByToken($projectid, $token, $options);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->getgetFileByToken: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **projectid** | **int**| Translation project identifier. |
 **token** | **string**| Token resulting from the asynchronous translation request. |
 **options** | **string**| JSON auxiliary options. | [optional]

### Return type

[**\ATLS\Api\Model\OutFile**](../Model/OutFile.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **ping**
> \ATLS\Api\Model\InlineResponse200 ping()

ping

Checking that the service is working properly. This method does NOT REQUIRE AUTHENTICATION.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);

try {
    $result = $apiInstance->ping();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->ping: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**\ATLS\Api\Model\InlineResponse200**](../Model/InlineResponse200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **translateAsynchronous**
> \ATLS\Api\Model\OutToken translateAsynchronous($body)

translateAsynchronous

An asynchronous translation request is generated, i.e. a review of a translation completed by a professional from the ATLS Global S.L. LSP division.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \stdClass; // object | Example of a revised translation

try {
    $result = $apiInstance->translateAsynchronous($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->translateAsynchronous: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**object**](../Model/object.md)| Example of a revised translation |

### Return type

[**\ATLS\Api\Model\OutToken**](../Model/OutToken.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

# **translateSynchronous**
> \ATLS\Api\Model\OutFile translateSynchronous($body)

translateSynchronous

Synchronous (non-human automatic translation) translation order request.  After the request, the service returns the file translated into the specified target language.

### Example
```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');
// Configure API key authorization: ApiKeyAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKey('X-ATRTS-API-Key', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = ATLS\Api\Configuration::getDefaultConfiguration()->setApiKeyPrefix('X-ATRTS-API-Key', 'Bearer');// Configure HTTP basic authorization: BasicAuth
$config = ATLS\Api\Configuration::getDefaultConfiguration()
              ->setUsername('YOUR_USERNAME')
              ->setPassword('YOUR_PASSWORD');


$apiInstance = new ATLS\Api\Api\RestapiApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);
$body = new \stdClass; // object | Example of synchronous machine translation

try {
    $result = $apiInstance->translateSynchronous($body);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling RestapiApi->translateSynchronous: ', $e->getMessage(), PHP_EOL;
}
?>
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**object**](../Model/object.md)| Example of synchronous machine translation |

### Return type

[**\ATLS\Api\Model\OutFile**](../Model/OutFile.md)

### Authorization

[ApiKeyAuth](../../README.md#ApiKeyAuth), [BasicAuth](../../README.md#BasicAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../../README.md#documentation-for-api-endpoints) [[Back to Model list]](../../README.md#documentation-for-models) [[Back to README]](../../README.md)

