<?php
/**
 * File
 *
 * PHP version 5
 *
 * @category Class
 * @package  ATLS\Api
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * AT-RTS
 *
 * AT-RTS (Remote Translation Service) is the web API which enables our translation systems to be integrated into our clients’ systems, from where the entire content translation process can be controlled.<br/>The web API, based on a SOAP web service, has REST interoperability from version 5.3.0.<br/>The operational functionalities are:<ul><li><b>Operating check:</b> Active service check.</li><li><b>Synchronous translation:</b> requests for automatic translation (non-human) orders.</li><li><b>Asynchronous translation:</b> Asynchronous requests for specialised professional translation orders.<br/>Each request returns a <b><i>token</i></b>, associated with the translation request, the purpose of which is to uniquely identify each work request so that the corresponding translation can be requested in the future once proofreading is complete.<br/>It should be noted that asynchronous translation requests have the option to indicate a <b><i>callback</i></b> URL, which involves activating a completed translation notification service, so that our clients can automate the completed request download process.<br/>To summarise, in this case, AT sends the requests directly to our clients’ systems for them to be located in their systems.<br/>Conceptually, at ATLS Global we guarantee the <b><i>return of translations</i></b> for asynchronous order requests to our clients’ infrastructure, taking into account that if the communication system fails <b><i>repeatedly a certain number of times</i></b> for any reason, a warning email would be sent to the email account that the client has specified during the request.</li><li><b>Translation return request:</b> Request to obtain a professional translation order from a token generated by the asynchronous translation request. If the order is not complete, it returns document status information.</li><li><b>Cancellation of a translation:</b> request for cancellation of previous asynchronous translation requests by token that have not been initiated. In this case, ATLS Global S.L. systems will validate that the indicated token has not started the translation process; if it has not started, the request will be cancelled.</li><li><b>List of requests:</b> Request regarding status and consumption of translation orders from the cut-off date, with the following information:<ul><li>projectid: AT project ID</li><li>token: Request token</li><li>sourcelang: Source language</li><li>targetlang: Target language</li>filename: Name associated with the request</li><li>wordcount: Number of words</li><li>status: Translation status<ul><li>10: Under review</li><li>20: Ready and pending delivery</li><li>30: Delivered</li><li>40: Canceled and deleted</li><li>50: Expired delivery</li><li>90: Documental entry error</li><li>100: Processing error</li></ul></li><li>urlcallback: (optional) completed translation return URL</li><li>errnotifiersendto (optional): translation return error notification email</li><li>dateinsert: Date of registration</li><li>type: Translation type, SYNCHRONOUS OR ASYNCHRONOUS.</li></ul></li></ul>
 *
 * OpenAPI spec version: 5.6.0
 * Contact: info@at-ls.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.58-SNAPSHOT
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace ATLS\Api\Model;

use \ArrayAccess;
use \ATLS\Api\ObjectSerializer;

/**
 * File Class Doc Comment
 *
 * @category Class
 * @description File information
 * @package  ATLS\Api
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class File implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'File';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'token_5' => 'string',
        'token' => 'string',
        'sourcelang' => 'string',
        'targetlang' => 'string',
        'filename' => 'string',
        'wordcount' => 'int',
        'idddv4' => 'string',
        'dateinsert' => '\DateTime',
        'auxdata' => 'string',
        'type' => 'int',
        'projectid' => 'int',
        'status' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'token_5' => null,
        'token' => null,
        'sourcelang' => null,
        'targetlang' => null,
        'filename' => null,
        'wordcount' => 'int32',
        'idddv4' => null,
        'dateinsert' => 'date-time',
        'auxdata' => null,
        'type' => 'int32',
        'projectid' => 'int32',
        'status' => 'int32'
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'token_5' => 'token_5',
        'token' => 'token',
        'sourcelang' => 'sourcelang',
        'targetlang' => 'targetlang',
        'filename' => 'filename',
        'wordcount' => 'wordcount',
        'idddv4' => 'idddv4',
        'dateinsert' => 'dateinsert',
        'auxdata' => 'auxdata',
        'type' => 'type',
        'projectid' => 'projectid',
        'status' => 'status'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'token_5' => 'setToken5',
        'token' => 'setToken',
        'sourcelang' => 'setSourcelang',
        'targetlang' => 'setTargetlang',
        'filename' => 'setFilename',
        'wordcount' => 'setWordcount',
        'idddv4' => 'setIdddv4',
        'dateinsert' => 'setDateinsert',
        'auxdata' => 'setAuxdata',
        'type' => 'setType',
        'projectid' => 'setProjectid',
        'status' => 'setStatus'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'token_5' => 'getToken5',
        'token' => 'getToken',
        'sourcelang' => 'getSourcelang',
        'targetlang' => 'getTargetlang',
        'filename' => 'getFilename',
        'wordcount' => 'getWordcount',
        'idddv4' => 'getIdddv4',
        'dateinsert' => 'getDateinsert',
        'auxdata' => 'getAuxdata',
        'type' => 'getType',
        'projectid' => 'getProjectid',
        'status' => 'getStatus'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }



    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['token_5'] = isset($data['token_5']) ? $data['token_5'] : null;
        $this->container['token'] = isset($data['token']) ? $data['token'] : null;
        $this->container['sourcelang'] = isset($data['sourcelang']) ? $data['sourcelang'] : null;
        $this->container['targetlang'] = isset($data['targetlang']) ? $data['targetlang'] : null;
        $this->container['filename'] = isset($data['filename']) ? $data['filename'] : null;
        $this->container['wordcount'] = isset($data['wordcount']) ? $data['wordcount'] : null;
        $this->container['idddv4'] = isset($data['idddv4']) ? $data['idddv4'] : null;
        $this->container['dateinsert'] = isset($data['dateinsert']) ? $data['dateinsert'] : null;
        $this->container['auxdata'] = isset($data['auxdata']) ? $data['auxdata'] : null;
        $this->container['type'] = isset($data['type']) ? $data['type'] : null;
        $this->container['projectid'] = isset($data['projectid']) ? $data['projectid'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets token_5
     *
     * @return string
     */
    public function getToken5()
    {
        return $this->container['token_5'];
    }

    /**
     * Sets token_5
     *
     * @param string $token_5 The token key is a string of alphanumeric characters generated by encryption from the ATLS Global SL system that acts as the unique identifier of the file associated with the asynchronous translation request.
     *
     * @return $this
     */
    public function setToken5($token_5)
    {
        $this->container['token_5'] = $token_5;

        return $this;
    }

    /**
     * Gets token
     *
     * @return string
     */
    public function getToken()
    {
        return $this->container['token'];
    }

    /**
     * Sets token
     *
     * @param string $token The token key is a string of alphanumeric characters generated using UUID encryption that acts as the unique identifier of the file associated with the asynchronous translation request.
     *
     * @return $this
     */
    public function setToken($token)
    {
        $this->container['token'] = $token;

        return $this;
    }

    /**
     * Gets sourcelang
     *
     * @return string
     */
    public function getSourcelang()
    {
        return $this->container['sourcelang'];
    }

    /**
     * Sets sourcelang
     *
     * @param string $sourcelang The sourcelang key is a source language code in ISO-639-3 format.
     *
     * @return $this
     */
    public function setSourcelang($sourcelang)
    {
        $this->container['sourcelang'] = $sourcelang;

        return $this;
    }

    /**
     * Gets targetlang
     *
     * @return string
     */
    public function getTargetlang()
    {
        return $this->container['targetlang'];
    }

    /**
     * Sets targetlang
     *
     * @param string $targetlang The targetlang key is a target language code in ISO-639-3 format.
     *
     * @return $this
     */
    public function setTargetlang($targetlang)
    {
        $this->container['targetlang'] = $targetlang;

        return $this;
    }

    /**
     * Gets filename
     *
     * @return string
     */
    public function getFilename()
    {
        return $this->container['filename'];
    }

    /**
     * Sets filename
     *
     * @param string $filename The filename key indicates the name of the file.
     *
     * @return $this
     */
    public function setFilename($filename)
    {
        $this->container['filename'] = $filename;

        return $this;
    }

    /**
     * Gets wordcount
     *
     * @return int
     */
    public function getWordcount()
    {
        return $this->container['wordcount'];
    }

    /**
     * Sets wordcount
     *
     * @param int $wordcount The wordcount key indicates the number of words in the file that have been translated.
     *
     * @return $this
     */
    public function setWordcount($wordcount)
    {
        $this->container['wordcount'] = $wordcount;

        return $this;
    }

    /**
     * Gets idddv4
     *
     * @return string
     */
    public function getIdddv4()
    {
        return $this->container['idddv4'];
    }

    /**
     * Sets idddv4
     *
     * @param string $idddv4 The idddv4 key indicates the internal identifier.
     *
     * @return $this
     */
    public function setIdddv4($idddv4)
    {
        $this->container['idddv4'] = $idddv4;

        return $this;
    }

    /**
     * Gets dateinsert
     *
     * @return \DateTime
     */
    public function getDateinsert()
    {
        return $this->container['dateinsert'];
    }

    /**
     * Sets dateinsert
     *
     * @param \DateTime $dateinsert The dateinsert key indicates the insertion date of the file.
     *
     * @return $this
     */
    public function setDateinsert($dateinsert)
    {
        $this->container['dateinsert'] = $dateinsert;

        return $this;
    }

    /**
     * Gets auxdata
     *
     * @return string
     */
    public function getAuxdata()
    {
        return $this->container['auxdata'];
    }

    /**
     * Sets auxdata
     *
     * @param string $auxdata The auxdata key indicates auxiliary values.
     *
     * @return $this
     */
    public function setAuxdata($auxdata)
    {
        $this->container['auxdata'] = $auxdata;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int $type The type key indicates how the translation has been requested, synchronous or asynchronous.
     *
     * @return $this
     */
    public function setType($type)
    {
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets projectid
     *
     * @return int
     */
    public function getProjectid()
    {
        return $this->container['projectid'];
    }

    /**
     * Sets projectid
     *
     * @param int $projectid The key projectid indicates the translation project identifier.
     *
     * @return $this
     */
    public function setProjectid($projectid)
    {
        $this->container['projectid'] = $projectid;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int $status The status key indicates the status of the translation.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    #[\ReturnTypeWillChange]
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    #[\ReturnTypeWillChange]
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    #[\ReturnTypeWillChange]
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
